ubuntu-location-service: com::ubuntu::location Namespace Reference

ubuntu-location-service .. An aggregating location service providing positioning and geocoding capabilities to applications.

Namespaces | Classes | Typedefs | Enumerations | Functions
com::ubuntu::location Namespace Reference

## Namespaces
| connectivity
| providers
| service
| units
| wgs84

## Classes
struct | AccuracyTraits
struct | Accuracy
struct | Clock
| Defines the timebase of the location service. More...
struct | Criteria
| Summarizes criteria of a client session with respect to functionality and accuracy for position, velocity and heading measurements. More...
class | DefaultProviderSelectionPolicy
class | FusionProvider
struct | FusionProviderSelectionPolicy
class | NewerOrMoreAccurateUpdateSelector
class | NewerUpdateSelector
struct | Position
| The Position struct models a position in the wgs84 coordinate system. More...
class | Provider
| The Provider class is the abstract base of all positioning providers. More...
class | ProviderEnumerator
class | ProviderFactory
struct | ProviderSelection
class | ProviderSelectionPolicy
class | ProxyProvider
struct | SpaceVehicle
| A space-vehicle as visible to providers. More...
struct | Update
| Templated class that wraps a value and timestamp. More...
struct | WithSource
class | UpdateSelector

## Typedefs
typedef boost::property_tree::ptree | Configuration
typedef units::Quantity< units::PlaneAngle > | Heading
template<typename T >
using | Optional = boost::optional< T >
typedef units::Quantity< units::Velocity > | Velocity
| Velocity is measured in m/s. More...

## Enumerations
enum class | AccuracyLevel { country , region , locality , postalcode , street , detailed , best = detailed , worst = country }
enum class | SatelliteBasedPositioningState { on , off }
| The SatelliteBasedPositioningState enum describes whether satellite assisted positioning is enabled or disabled. More...
enum class | WifiAndCellIdReportingState { on , off }

## Functions
template<typename T >
std::ostream & | operator<< (std::ostream &out, const Accuracy< T > &update)
Criteria | operator+ (const Criteria &lhs, const Criteria &rhs)
| operator + merges lhs and rhs such that satisfying the new criteria satisfies lhs and rhs. More...
void | init (int *argc, char ***argv)
| Initializes the library. More...
void | shutdown ()
| Shuts down the library and frees all acquired resources. More...
std::ostream & | operator<< (std::ostream &out, const Position &position)
units::Quantity< units::Length > | haversine_distance (const Position &p1, const Position &p2)
Provider::Features | operator| (Provider::Features lhs, Provider::Features rhs)
Provider::Features | operator& (Provider::Features lhs, Provider::Features rhs)
Provider::Requirements | operator| (Provider::Requirements lhs, Provider::Requirements rhs)
Provider::Requirements | operator& (Provider::Requirements lhs, Provider::Requirements rhs)
bool | operator== (const ProviderSelection &lhs, const ProviderSelection &rhs)
std::ostream & | operator<< (std::ostream &, SatelliteBasedPositioningState)
| Pretty prints the given state to the given stream. More...
std::istream & | operator>> (std::istream &, SatelliteBasedPositioningState &)
| Parses the state from the given stream. More...
std::ostream & | operator<< (std::ostream &out, const SpaceVehicle &sv)
template<typename T >
std::ostream & | operator<< (std::ostream &out, const Update< T > &update)
| Pretty-prints the update to the provided output stream. More...
std::ostream & | operator<< (std::ostream &, WifiAndCellIdReportingState)
| Pretty prints the given state to the given stream. More...
std::istream & | operator>> (std::istream &, WifiAndCellIdReportingState &)
| Parses the state from the given stream. More...

## Typedef Documentation

## ◆ Configuration

typedef boost::property_tree::ptree com::ubuntu::location::Configuration

Definition at line 29 of file configuration.h.

## ◆ Heading

typedef units::Quantity<units::PlaneAngle> com::ubuntu::location::Heading

Heading is measured in ° deviation from true north.

Definition at line 30 of file heading.h.

## ◆ Optional

template<typename T >

using com::ubuntu::location::Optional = typedef boost::optional<T>

Definition at line 30 of file optional.h.

## ◆ Velocity

typedef units::Quantity<units::Velocity> com::ubuntu::location::Velocity

Velocity is measured in m/s.

Definition at line 30 of file velocity.h.

## Enumeration Type Documentation

## ◆ AccuracyLevel

enum com::ubuntu::location::AccuracyLevel
| strong

Enumerator
country |
region |
locality |
postalcode |
street |
detailed |
best |
worst |

Definition at line 29 of file accuracy.h.

## ◆ SatelliteBasedPositioningState

enum com::ubuntu::location::SatelliteBasedPositioningState
| strong

The SatelliteBasedPositioningState enum describes whether satellite assisted positioning is enabled or disabled.

Enumerator
on | Satellite assisted positioning is on.
off | Satellite assisted positioning is off.

Definition at line 33 of file satellite_based_positioning_state.h.

## ◆ WifiAndCellIdReportingState

enum com::ubuntu::location::WifiAndCellIdReportingState
| strong

Enumerator
on | Wifi and Cell Ids might be reported to online location services.
off | Wifi and Cell Ids are not reported. This is the default value.

Definition at line 29 of file wifi_and_cell_reporting_state.h.

## Function Documentation

## ◆ haversine_distance()

units::Quantity<units::Length> com::ubuntu::location::haversine_distance | ( | const Position & | p1,
|  | const Position & | p2
| ) |  |

## ◆ init()

void com::ubuntu::location::init | ( | int * | argc,
|  | char *** | argv
| ) |  |

Initializes the library.

## ◆ operator&() [1/2]

Provider::Features com::ubuntu::location::operator& | ( | Provider::Features | lhs,
|  | Provider::Features | rhs
| ) |  |

## ◆ operator&() [2/2]

Provider::Requirements com::ubuntu::location::operator& | ( | Provider::Requirements | lhs,
|  | Provider::Requirements | rhs
| ) |  |

## ◆ operator+()

Criteria com::ubuntu::location::operator+ | ( | const Criteria & | lhs,
|  | const Criteria & | rhs
| ) |  |

operator + merges lhs and rhs such that satisfying the new criteria satisfies lhs and rhs.

## ◆ operator<<() [1/6]

std::ostream& com::ubuntu::location::operator<< | ( | std::ostream & | ,
|  | SatelliteBasedPositioningState |
| ) |  |

Pretty prints the given state to the given stream.

## ◆ operator<<() [2/6]

std::ostream& com::ubuntu::location::operator<< | ( | std::ostream & | ,
|  | WifiAndCellIdReportingState |
| ) |  |

Pretty prints the given state to the given stream.

## ◆ operator<<() [3/6]

template<typename T >

std::ostream& com::ubuntu::location::operator<< | ( | std::ostream & | out,
|  | const Accuracy< T > & | update
| ) |  |
| inline

Definition at line 68 of file accuracy.h.

References com::ubuntu::location::Accuracy< T >::value.

## ◆ operator<<() [4/6]

std::ostream& com::ubuntu::location::operator<< | ( | std::ostream & | out,
|  | const Position & | position
| ) |  |

## ◆ operator<<() [5/6]

std::ostream& com::ubuntu::location::operator<< | ( | std::ostream & | out,
|  | const SpaceVehicle & | sv
| ) |  |
| inline

Definition at line 95 of file space_vehicle.h.

References com::ubuntu::location::SpaceVehicle::azimuth, com::ubuntu::location::SpaceVehicle::beidou, com::ubuntu::location::SpaceVehicle::compass, com::ubuntu::location::SpaceVehicle::elevation, com::ubuntu::location::SpaceVehicle::galileo, com::ubuntu::location::SpaceVehicle::glonass, com::ubuntu::location::SpaceVehicle::gps, com::ubuntu::location::SpaceVehicle::has_almanac_data, com::ubuntu::location::SpaceVehicle::has_ephimeris_data, com::ubuntu::location::SpaceVehicle::Key::id, com::ubuntu::location::SpaceVehicle::irnss, com::ubuntu::location::SpaceVehicle::key, com::ubuntu::location::SpaceVehicle::qzss, com::ubuntu::location::SpaceVehicle::snr, com::ubuntu::location::SpaceVehicle::Key::type, com::ubuntu::location::SpaceVehicle::unknown, and com::ubuntu::location::SpaceVehicle::used_in_fix.

## ◆ operator<<() [6/6]

template<typename T >

std::ostream& com::ubuntu::location::operator<< | ( | std::ostream & | out,
|  | const Update< T > & | update
| ) |  |
| inline

Pretty-prints the update to the provided output stream.

Parameters

  out | The stream to write to.
  update | The value to be printed.

Definition at line 82 of file update.h.

References com::ubuntu::location::Update< T >::value, and com::ubuntu::location::Update< T >::when.

## ◆ operator==()

bool com::ubuntu::location::operator== | ( | const ProviderSelection & | lhs,
|  | const ProviderSelection & | rhs
| ) |  |
| inline

Definition at line 52 of file provider_selection.h.

References com::ubuntu::location::ProviderSelection::heading_updates_provider, com::ubuntu::location::ProviderSelection::position_updates_provider, and com::ubuntu::location::ProviderSelection::velocity_updates_provider.

## ◆ operator>>() [1/2]

std::istream& com::ubuntu::location::operator>> | ( | std::istream & | ,
|  | SatelliteBasedPositioningState & |
| ) |  |

Parses the state from the given stream.

## ◆ operator>>() [2/2]

std::istream& com::ubuntu::location::operator>> | ( | std::istream & | ,
|  | WifiAndCellIdReportingState & |
| ) |  |

Parses the state from the given stream.

## ◆ operator|() [1/2]

Provider::Features com::ubuntu::location::operator| | ( | Provider::Features | lhs,
|  | Provider::Features | rhs
| ) |  |

## ◆ operator|() [2/2]

Provider::Requirements com::ubuntu::location::operator| | ( | Provider::Requirements | lhs,
|  | Provider::Requirements | rhs
| ) |  |

## ◆ shutdown()

void com::ubuntu::location::shutdown | ( |  | ) |

Shuts down the library and frees all acquired resources.